#include <iostream.h>
#include <conio.h>

class node
{
	private:	float data; node* link;

	public:
   	friend class linklist;
};

class linklist
{
	private: node* root;

	public:
		linklist(){root=NULL;}

      void add(float);
   	float getdata(int)const;
      const node* getlink(int)const;
   	void setdata(int,float)const;
   	void insert(int,float)const;
   	void remove(float)const;
   	float remove_at(int)const;
   	void traverse()const;

      bool ismember(float)const;  //ismember checks whether the given data already exists in the linklist obj or not
};

class set:public linklist
{
	public:
   	void add(float);
      void setdata(int,float)const; //overridden fns to specialize the definitions of parent class fns in child class
      void insert(int,float)const;

      void message()const;          //prints error message if data already exists in the list
};

class setofint:protected set
{
	public:
   	void add(float);
      void setdata(int,float)const; //overridden fns
      void insert(int,float)const;

      bool isint(float)const;       //checks whether the given data is int or not    (constraint)
      void message()const;          //prints error message if data is not int
};


class setofnaturals:private setofint
{
	public:
   	void add(float);
      void setdata(int,float)const;
      void insert(int,float)const;

      bool isnatural(float)const;   //checks wether the given data is a natural num or not
      void message()const;         //prints error message if data is not a natural num
};



//linklist class fns definitions:
		void linklist::add(float dat)
   	{
   		node* curr=root;
      	node* temp= new node;

      	temp->data=dat;
      	temp->link=NULL;

      	if(curr==NULL)
      		root=temp;
      	else
      	{
      		while(curr->link!=NULL)
      			curr=curr->link;
         	curr->link=temp;
      	}
   	}

   	float linklist::getdata(int index)const
   	{
    		node* curr=root;
      	for(int i=1;(curr!=NULL&&i<index);i++)
      		curr=curr->link;
      	return curr->data;
   	}

      const node* linklist::getlink(int index)const
      {
    		node* curr=root;
      	for(int i=1;(curr!=NULL&&i<index);i++)
      		curr=curr->link;
      	return curr->link;
   	}

   	void linklist::setdata(int index,float dat)const
   	{
    		node* curr=root;
      	for(int i=1;(curr!=NULL&&i<index);i++)
      		curr=curr->link;
      	curr->data=dat;
   	}

   	void linklist::insert(int index,float dat)const
   	{
    		node* curr=root;
      	node* neo=new node;
      	node* t;

      	for(int i=1;(curr!=NULL&&i<(index-1));i++)
         	curr=curr->link;

         t=curr->link;
         curr->link=neo;
         neo->data=dat;
         neo->link=t;
   	}

   	void linklist::remove(float dat)const
   	{
    		node* curr=root;
      	node* prev=root;

      	while(curr!=NULL)
      	{
         	if(curr->data==dat)
      		{
            	prev->link=curr->link;
      			delete curr;
               curr=prev->link;
            }
            else
            {
            	prev=curr;
            	curr=curr->link;
            }
      	}
   	}

   	float linklist::remove_at(int index)const
   	{
      	node* curr=root;
      	node* prev=NULL;
      	float t;

      	for(int i=1;(curr!=NULL&&i<index);i++)
      	{
      		prev=curr;
      		curr=curr->link;
      	}
      	prev->link=curr->link;
      	t=curr->data;
      	delete curr;
      	return t;
   	}

   	void linklist::traverse()const
   	{
   		node* curr=root;
      	while(curr!=NULL)
      	{
      		cout<<"item "<<curr->data<<'\n';
            curr=curr->link;
      	}
   	}

      bool linklist::ismember(float dat)const
      {
      	node* curr=root;
         while(curr!=NULL)
         {
         	if(curr->data==dat)
            	return true;
         	curr=curr->link;
         }
         return false;
      }



//set clas fns definitions:
   	void set::add(float dat)
      {
      	if(ismember(dat))
         	message();
         else
         	linklist::add(dat);
      }

      void set::setdata(int index,float dat)const
      {
         if(ismember(dat))
         	message();
         else
         	linklist::setdata(index,dat);
      }

      void set::insert(int index,float dat)const
      {
      	if(ismember(dat))
          	message();
         else
         	linklist::insert(index,dat);
   	}

      void set::message()const{cout<<"\nError: repeatition is not allowed in any set ";}



//setofint clas fns definitions:
      void setofint::add(float dat)
      {
      	if(isint(dat))
         	set::add(dat);
         else
         	message();
      }

      void setofint::setdata(int index,float dat)const
      {
         if(isint(dat))
         	set::setdata(index,dat);
         else
         	message();
      }

      void setofint::insert(int index,float dat)const
      {
      	if(isint(dat))
          	set::insert(index,dat);
         else
         	message();
      }

      bool setofint::isint(float dat)const
      {
      	int t=dat;
         if(t==dat)
         	return true;
         else
         	return false;
      }

      void setofint::message()const{cout<<"\nError: floating point is not allowed ";}



//setofnaturals clas fns definitions:
      void setofnaturals::add(float dat)
      {
      	if(isnatural(dat))
         	setofint::add(dat);
         else
         	message();
      }

      void setofnaturals::setdata(int index,float dat)const
      {
         if(isnatural(dat))
         	setofint::setdata(index,dat);
         else
         	message();
      }

      void setofnaturals::insert(int index,float dat)const
      {
      	if(isnatural(dat))
          	setofint::insert(index,dat);
         else
         	message();
      }

      bool setofnaturals::isnatural(float dat)const
      {
         if(dat>0)
         	return true;
         else
         	return false;
      }

      void setofnaturals::message()const{cout<<"\nError: negative number or 0 is not allowed ";}


main()
{
	linklist lst;

   lst.add(4);	lst.add(5.2);	lst.add(5.5);	lst.add(9);
   lst.insert(3,-7); 	lst.setdata(5,6);
   lst.remove(5);	lst.remove_at(2);
   lst.traverse();

   set s;

   s.add(3);	s.add(3.5),	s.add(4);	s.add(-9);	s.add(4);
   s.insert(2,3.5); 	s.setdata(2,5);
   s.remove(3.5);	s.remove_at(2);
   cout<<endl;	s.traverse();

   setofint z;

   cout<<endl;
   z.add(4);	z.add(14);	z.add(2);	z.add(3);	z.add(4);	z.add(2.4);
   z.insert(2,6);	z.setdata(2,2);

//   z.remove(4);	z.remove_at(2);	z.traverse(); public members of parent class are not accessible in protected inheritance

   setofnaturals n;

   cout<<endl;
   n.add(1);	n.add(10);	n.add(-1.2);	n.add(-2);	n.add(2);	n.add(6);
   n.insert(2,1);	n.insert(3,4);	n.setdata(4,6.7);

//   n.remove(2);	n.remove_at(3);	n.traverse();	public members of parent class are not accessible in private inheritance

   getch();
}
